#
#  wizard.tcl
#
#  $Id: wizard.tcl,v 1.11 2003/08/04 14:49:56 source Exp $
#
#  Generic TCL functions for Wizard pages
#
#  (C)Copyright 2003 OpenLink Software.
#  All Rights Reserved.
#
#  The copyright above and this notice must be preserved in all
#  copies of this source code.  The copyright above does not
#  evidence any actual or intended publication of this source code.
#
#  This is unpublished proprietary trade secret of OpenLink Software.
#  This source code may not be copied, disclosed, distributed, demonstrated
#  or licensed except as authorized by OpenLink Software.
#


#----------------------------------------------------------------------
#  Wizard headers
#----------------------------------------------------------------------

proc wizard_page_head {title} {
  global pages

  # 
  #  Start the page
  #
  html {<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">}
  html \n<html>\n
  html <head>\n
  html <title>$title</title>\n

  #
  #  Set META tags
  #
  html <meta name="author" content="OpenLink Software">\n
  html <meta http-equiv="Content-Type" content="text/html\; charset=UTF-8">\n

  #
  #  Load generic javascript functions
  #
  html <script type="text/javascript" src="/wizard.js"></script>\n
  html <link rel="stylesheet" type="text/css" title="wizard" href="/wizard.css">\n
}


proc wizard_page_body {} {
  html </head>\n
  html {<body 
    bgcolor="#99BBCC"
    text="#000000" 
    onload="WizardOnLoad()"
    onunload="WizardOnUnload()"
    class="wizard_body">}
  html \n
}


proc wizard_page_end {} {
  html </body>\n</html>\n
}


proc wizard_form_start {name} {
  html <form name="$name" method="POST" action="">\n
  html <table border="0" cellpadding="0" cellspacing="0" width="100%">\n
}

proc wizard_form_end {} {
  html </table>\n</form>\n
}


proc wizard_form_desc {desc} {
  # Description
  html <tr><td height="60px">
  html <img src="/images/oplconf.gif" align="left" alt="">
  html "$desc"
  html </td>\n

  # Exit button
  html <td align="right" valign="bottom">
  wizard_button "" 75 "Exit" "self.close()"
  html <img src="/images/1x1.gif" width="1px" height="1" name="botright" alt="">
  html </td></tr>\n
}


#----------------------------------------------------------------------
#  Wizard menu
#----------------------------------------------------------------------

proc wizard_odbc_menu {thistab} {
    global GlobalProductID

    html <tr><td colspan="2" valign="top">\n
    html <table border="0" cellpadding="0" cellspacing="0"><tr>\n

    #
    #  tab 1 - Data Sources
    #
    html <td><a href="/scripts/wods">
    if {$thistab==1} {
	html <img src="/images/data_u.gif" border="0" alt="">
    } else {
	html <img src="/images/data_d.gif" border="0" alt="">
    }
    html </a></td>\n

    #
    #  tab 2 - Server Types
    #
    html <td><a href="/scripts/wost">
    if {$thistab==2} {
	html <img src="/images/server_u.gif" border="0" alt="">
    } else {
	html <img src="/images/server_d.gif" border="0" alt="">
    }
    html </a></td>\n

    #
    #  tab 3 - Communication parameters
    #
    html <td><a href="/scripts/woco">
    if {$thistab==3} {
	html <img src="/images/comms_u.gif" border="0" alt="">
    } else {
	html <img src="/images/comms_d.gif" border="0" alt="">
    }
    html </a></td>\n

    #
    #  tab 4 - ODBC Debug file
    #
    html <td><a href="/scripts/wod">
    if {$thistab==4} {
	html <img src="/images/trace_u.gif" border="0" alt="">
    } else {
	html <img src="/images/trace_d.gif" border="0" alt="">
    }
    html </a></td>\n

    #
    #  tab 5 - About
    #
    html <td><a href="/scripts/woab">
    if {$thistab==5} {
	html <img src="/images/about_u.gif" border="0" alt="">
    } else {
	html <img src="/images/about_d.gif" border="0" alt="">
    }
    html </a></td>\n

    html </tr></table>\n
    html </td></tr>\n
}


#----------------------------------------------------------------------
#  Wizard layout + input functions
#----------------------------------------------------------------------

proc wizard_label {label var} {
  html <table><tr><td align="right" width="120px" class="wizard_label">
  html <label for="$var">$label:</label>
  html </td><td>\n
}


proc wizard_endrow {} {
  html </td></tr></table>\n
}


#
#  Select list
#
proc wizard_selectlist_start {size name} {
  #
  #  Workaround for Netscape 4.X and earlier
  #
  set width "class=\"wizard_selectlist\""
  if {[navigator appName] == "Netscape"} {
    scan [navigator appVersion] "%d" nv
    if {[expr $nv < "5"]} {
      set width "width=\"450\""
    }
  }

  html <td valign="top"><select name="$name" size="$size" $width>\n
}

proc wizard_selectlist_end {} {
  html </select></td>\n
}
  

#
#  Input text field
#
proc wizard_input_text {label size var readonly} {
  global dsnCfg undef

  #
  #  Split size:max field
  #
  set maxl {}
  if {[regexp "(.+):(.+)" $size full size2 maxlen]} {
    set maxl maxlength=$maxlen
    set size $size2
  }

  #
  #  Workaround for Netscape 4.77 and earlier
  #
  if {[navigator appName] == "Netscape"} {
    scan [navigator appVersion] "%f" nv
    if {[expr $nv < "4.77"]} {
      set size [expr 1 + ($size * 60)/100]
    }
  }

  #
  #  Label
  #
  html <table><tr><td align="right" width="120px" class="wizard_label">
  html <label for="$var">$label:</label></td>

  #
  #  Input box
  #
  html <td><input type=text id=\"$var\" name=\"$var\" $maxl size=\"$size\"
  html class="wizard_text"

  #
  #  Value
  #
  if {$dsnCfg($var) != $undef} {
    html value=\"
    html -escape $dsnCfg($var)
    html \"
  }

  #
  #  Readonly?
  #
  if {$readonly} {
    html { readonly }
    html {onfocus="if (!document.all && !document.getElementById) this.blur()"}
  }

  #
  #  End of row
  #
  html "></td></tr></table>\n"
}


#
#  Input password field
#
proc wizard_input_pwd {label size var readonly} {
  global dsnCfg undef

  #
  #  Split size:max field
  #
  set maxl {}
  if {[regexp "(.+):(.+)" $size full size2 maxlen]} {
    set maxl maxlength=$maxlen
    set size $size2
  }

  #
  #  Workaround for Netscape 4.77 and earlier
  #
  if {[navigator appName] == "Netscape"} {
    scan [navigator appVersion] "%f" nv
    if {[expr $nv < "4.77"]} {
      set size [expr 1 + ($size * 60)/100]
    }
  }

  #
  #  Label
  #
  html <table><tr><td align="right" width="120px" class="wizard_label">
  html <label for="$var">$label:</label></td>

  #
  #  Input box
  #
  html <td><input type=password id=\"$var\" name=\"$var\" $maxl size=\"$size\"
  html class="wizard_text"

  #
  #  Value
  #
  if {$dsnCfg($var) != $undef} {
    html value=\"
    html -escape $dsnCfg($var)
    html \"
  }

  #
  #  Readonly?
  #
  if {$readonly} {
    html { readonly }
    html { onfocus="if (!document.all && !document.getElementById) this.blur()"}
  }

  #
  #  End of row
  #
  html "></td></tr></table>\n"
}


#
#  Input checkbox
#
proc wizard_checkbox {name desc} {
  global dsnCfg

  html <table><tr><td align="right" width="20px">
  html "<input type=checkbox name=\"$name\" "
  if {[IsTrue $dsnCfg($name)]} { html " checked" }
  html "></td>"

  #
  #  description
  #
  html <td style="wizard_checkbox">$desc</td>

  #
  #  End of row
  #
  html </tr></table>\n
}


proc wizard_checkbox2 {name desc} {
  global dsnCfg

  #
  #  Label
  #
  html <table><tr><td align="right" width="120px" class="wizard_label">
  html <label for="$name">$desc:</label></td>

  html <td><input type=checkbox name="$name" id="$name"
  if {[IsTrue $dsnCfg($name)]} { html " checked" }
  html "></td>"

  #
  #  End of row
  #
  html </tr></table>\n
}


#
#  Input textarea
#
proc wizard_input_textarea {cols rows name} {
  global dsnCfg undef

  #
  #  Workaround for Netscape 4.x 
  #
  set width ""
  scan [navigator appVersion] "%d" nv
  if {[navigator appName] == "Netscape" && $nv <= 4} {
    set width  "width=\"400px\" wrap=\"off\""
  }

  html "<textarea cols=\"$cols\" rows=\"$rows\" name=\"$name\" $width "
  html "class=\"wizard_textarea\">\n"

  if {$dsnCfg($name) != $undef} {
    set dsnCfg($name) [join [splitnotnull $dsnCfg($name) "\n\r^"] "\n"]
    html $dsnCfg($name)\n
  }
  html </textarea>\n
}


#
#  Fixed size button
#
proc wizard_button {name width label onclick} {

  if {$name == ""} {
    html "<input type=\"button\""
  } else {
    html "<input type=\"submit\" name=\"$name\""
  }

  #
  #  Workaround for Netscape 4.x 
  #
  scan [navigator appVersion] "%d" nv
  if {[navigator appName] == "Netscape" && $nv <= 4} {
    html " value=\"$label\" width=\"${width}px\""
  } else {
    html " value=\"$label\" size=\"${width}px\" style=\"width : ${width}px\""
  }

  if {$onclick !=""} {
      html " onClick=\'$onclick\'"
  }
  html " class=\"wizard_button\">\n"
}


#----------------------------------------------------------------------
#  Wizard layout + input functions
#  Basic input validation
#----------------------------------------------------------------------
proc CheckValidHost {id} {
  if {$id != "" && ![regexp {^[a-zA-Z0-9]([a-zA-Z0-9_ .:-]|\(|\))*$} $id]} {
    return 0;
  }

  return 1;
}

proc CheckValidInteger {id} {
  if {$id != "" && ![regexp {^[0-9]*$} $id]} {
    return 0;
  }

  return 1;
}


proc CheckValidUID {id} {
  if {$id != "" && ![regexp {^[a-zA-Z][a-zA-Z0-9_-]+$} $id]} {
    return 0;
  }

  return 1;
}

proc CheckValidDB {id} {
  if {$id != "" && ![regexp {^[a-zA-Z0-9_\\/][a-zA-Z0-9_\\/.:@ -]*$} $id]} {
    return 0;
  }

  return 1;
}

proc CheckValidText {id} {
  if {$id != "" && [regexp {[;]} $id]} {
    return 0;
  }

  return 1;
}

proc CheckValidID {id} {
  if {$id != "" && ![regexp {^[a-zA-Z_][a-zA-Z0-9_ .:-]*$} $id]} {
    return 0;
  }

  return 1;
}

proc CheckValidZC {id} {
  if {$id != "" && ![regexp {^[a-zA-Z]([a-zA-Z0-9_ .:-]|\(|\))*$} $id]} {
    return 0;
  }

  return 1;
}


#
#
#
proc wizard_label_opt {label var readonly} {
  global optCfg

  html <table><tr>
  html <td><input type="checkbox" name="c-$var" id="c-$var"
  if {[IsTrue $optCfg($var)]} { html " checked" }
  if {$readonly} { html " disabled readonly" }
  html ></td>
  html <td align="right" width="140px" class="wizard_label_opt">
  html <label for="$var">$label:</label>
  html </td><td>\n
}

#
#  Input text field
#
proc wizard_input_text_opt {label size var} {
  global dsnCfg optCfg undef

  #
  #  Split size:max field
  #
  set maxl {}
  if {[regexp "(.+):(.+)" $size full size2 maxlen]} {
    set maxl maxlength=$maxlen
    set size $size2
  }

  #
  #  Workaround for Netscape 4.77 and earlier
  #
  if {[navigator appName] == "Netscape"} {
    scan [navigator appVersion] "%f" nv
    if {[expr $nv < "4.77"]} {
      set size [expr 1 + ($size * 60)/100]
    }
  }

  #
  #  Checkbox
  #
  html <table><tr>
  html <td><input type="checkbox" name="c-$var" id="c-$var"
  if {[IsTrue $optCfg($var)]} { html " checked" }
  html " onclick=\"opl_set_state (this, this.form.$var)\""
  html ></td>

  #
  #  Label
  #
  html <td align="right" width="140px" class="wizard_label_opt">
  html <label for="$var">$label:</label></td>

  #
  #  Input box
  #
  html <td><input type=text id=\"$var\" name=\"$var\" $maxl size=\"$size\"
  html class="wizard_text"

  #
  #  Value
  #
  if {$dsnCfg($var) != $undef} {
    html value=\"
    html -escape $dsnCfg($var)
    html \"
  }

  #
  #  Option enabled?
  #
  if {![IsTrue $optCfg($var)]} { 
    html { disabled }
  }

  #
  #  End of row
  #
  html "></td></tr></table>\n"
}


#
#  Input password field
#
proc wizard_input_pwd_opt {label size var} {
  global dsnCfg optCfg undef

  #
  #  Split size:max field
  #
  set maxl {}
  if {[regexp "(.+):(.+)" $size full size2 maxlen]} {
    set maxl maxlength=$maxlen
    set size $size2
  }

  #
  #  Workaround for Netscape 4.77 and earlier
  #
  if {[navigator appName] == "Netscape"} {
    scan [navigator appVersion] "%f" nv
    if {[expr $nv < "4.77"]} {
      set size [expr 1 + ($size * 60)/100]
    }
  }

  #
  #  Checkbox
  #
  html <table><tr>
  html <td><input type="checkbox" name="c-$var" id="c-$var"
  if {[IsTrue $optCfg($var)]} { html " checked" }
  html " onclick=\"opl_set_state (this, this.form.$var)\""
  html ></td>

  #
  #  Label
  #
  html <td align="right" width="140px" class="wizard_label_opt">
  html <label for="$var">$label:</label></td>

  #
  #  Input box
  #
  html <td><input type=password id=\"$var\" name=\"$var\" $maxl size=\"$size\"
  html class="wizard_text"

  #
  #  Value
  #
  if {$dsnCfg($var) != $undef} {
    html value=\"
    html -escape $dsnCfg($var)
    html \"
  }

  #
  #  Option enabled?
  #
  if {![IsTrue $optCfg($var)]} {
    html { disabled }
  }

  #
  #  End of row
  #
  html "></td></tr></table>\n"
}


proc wizard_checkbox_opt {var desc} {
  global dsnCfg optCfg

  #
  #  Checkbox
  #
  html <table><tr>
  html <td><input type="checkbox" name="c-$var" id="c-$var"
  if {[IsTrue $optCfg($var)]} { html " checked" }
  html " onclick=\"opl_set_state (this, this.form.$var)\""
  html ></td>

  #
  #  Label
  #
  html <td align="right" width="140px" class="wizard_label_opt">
  html <label for="$var">$desc:</label></td>

  html <td><input type=radio name="$var" id="$var" value="Yes"
  if {[IsTrue $dsnCfg($var)]} { html " checked" }
  html ">Yes</td>"

  html <td><input type=radio name="$var" id="$var" value="No"
  if {![IsTrue $dsnCfg($var)]} { html " checked" }
  html ">No</td>"

  #
  #  End of row
  #
  html </tr></table>\n
}
